---
title: DataTransferItem.getAsString()
slug: Web/API/DataTransferItem/getAsString
tags:
  - API
  - DataTransferItem
  - HTML DOM
  - HTML Drag and Drop API
  - Method
  - Reference
  - drag and drop
  - getAsString
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DataTransferItem.getAsString()</code></strong> method invokes the given callback with the drag data item's string data as the argument if the item's {{domxref("DataTransferItem.kind","kind")}} is a <em>Plain unicode string</em> (i.e. <code>kind</code> is <code>string</code>).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>dataTransferItem</em>.getAsString(callback);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>callback</code></dt>
 <dd>A callback function that has access to the {{domxref("DataTransferItem","data transfer item's")}} string data. See {{anch("Callback")}} below for details.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}</p>

<h2 id="Callback">Callback</h2>

<p>The callback parameter is a callback function which accepts one parameter:</p>

<dl>
 <dt>{{domxref("DOMString")}}</dt>
 <dd>The drag data item's string data.</dd>
</dl>

<p>The callback return value is <code>undefined</code>.</p>

<h2 id="Example">Example</h2>

<p>This example shows the use of the <code>getAsString()</code> method as an <em>inline function</em> in a {{event("drop")}} event handler.</p>

<pre class="brush: js">function drop_handler(ev) {
 console.log("Drop");
 ev.preventDefault();
 var data = ev.dataTransfer.items;
 for (var i = 0; i &lt; data.length; i += 1) {
   if ((data[i].kind == 'string') &amp;&amp;
       (data[i].type.match('^text/plain'))) {
     // This item is the target node
     data[i].getAsString(function (s){
       ev.target.appendChild(document.getElementById(s));
     });
   } else if ((data[i].kind == 'string') &amp;&amp;
              (data[i].type.match('^text/html'))) {
     // Drag data item is HTML
     console.log("... Drop: HTML");
   } else if ((data[i].kind == 'string') &amp;&amp;
              (data[i].type.match('^text/uri-list'))) {
     // Drag data item is URI
     console.log("... Drop: URI");
   } else if ((data[i].kind == 'file') &amp;&amp;
              (data[i].type.match('^image/'))) {
     // Drag data item is an image file
     var f = data[i].getAsFile();
     console.log("... Drop: File ");
   }
 }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interaction.html#dom-datatransferitem-getasstring','getAsString()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'editing.html#dom-datatransferitem-getasstring','getAsString()')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot fo HTML WHATWG document</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransferItem.getAsString")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DataTransfer.getData()")}}</li>
</ul>
